# This file is in the public domain.

character miko

image miko happy    : "lemma/Char11.png"
image miko vhappy   : "lemma/Char12.png"
image miko mad      : "lemma/Char14.png"
image miko mischief : "lemma/Char16.png"
image store18       : "lemma/Store 18.JPG"
image store19       : "lemma/Store 19.JPG"
image store20       : "lemma/Store 20.JPG"
image store21       : "lemma/Store 21.JPG"
image black         : "images/black.png"

$ everything = False
$ save('everything')

$ name = None
$ save('name')

$ asked = False
$ save('asked')

scene store19
show miko happy

miko "Hello, and welcome to the Ren'Py demo program. You can use the
      mouse or keyboard to make menu choices and dismiss dialogs."

miko "Good!"

miko "Today, I'll be showing you the features of Ren'Py, and teaching
      you how to write your own games with it."

miko "Before we start, do you have any questions?"

menu m1:
    "Ask about Miko.":

        $ asked = True

        miko "Hm... I'm a college student who's teaching people part-time to
              earn some money for books and tickets."        
        
    "No, I don't have any questions.":
        pass

miko "There are two talks I can give on Ren'Py. The first is on the
      features of Ren'Py, and the second is about writing game scripts.
      Which would you like to hear about?"

menu topic1:
    "I'd like to hear about..."
    "... Ren'Py features.":
        jump features

    "... writing scripts.":
        jump scripts


label features:

    miko "Ren'Py was written to allow people to write \"Visual Novel\"
          games without having to write all of the game management and
          user interface code themselves."

    miko "In this way, it's similar to the various languages used in
          to write text adventures. (Like TADS, INFORM, and ADRIFT.)"

    show miko mischief

    miko "But it has better support for images."

    show miko happy

    miko "When using Ren'Py, a game author writes a script file that
          contains commands to show and hide pictures, display dialogue,
          and pop up menus."

    miko "Script files also can contain commands that can be used to
          change the flow of the script, and embedded Python code to do
          more complicated things."

    miko "Ren'Py takes care of loading and running these scripts.
          It also handles management of the screen and input, and
          loading and saving the game state."

    miko "This lets the game author focus on the art and the story."

    miko "You've already seen many of the Ren'Py features, such as dialogue
          and menus. If you want to see loading and saving, hit ESC to call
          up the command menu."

    miko "If you want to see all the features in action, ask me about
          writing scripts."

    jump end

label scripts:

    miko "Okay, we'll talk about writing scripts."

    "Miko pulls out a folder entited \"Writing Ren'Py Scripts\"."

    miko "There are a lot of things we can talk about. Is there anything
          in particular you want to know?"

    $ everything = 0

    menu m2:
        "I'd like to know about..."
        
        "... everything.":
            $ everything = 1

        "... how to follow along.":
            jump reading

        "... structure.":
            jump structure

        "... dialogue.":
            jump dialogue

        "... menus.":
            jump menus

        "... pictures and scenes.":
            jump scenes

        "... control flow":
            jump control

        "... python.":
            jump python

        "... what isn't implemented yet.":
            jump todo

label reading:

    miko "While I'll be talking about what renpy scripts can do,
          it might help if you can see the script I'm working from."

    miko "If you want to do that, open the file \"demo.rpy\" in your
          favorite text editor. Then, leave it open and come back."

    miko "You can follow what I'm saying in the script. Search
          'label reading:' to find where we are now."

    miko "It's best if you can follow along both here and in the script."

    show miko mischief

    miko "Having two monitors is good."

    show miko happy

if not everything:
    jump end

label structure:

    miko "This part is a bit boring, but we'll get through it."

    miko "Ren'Py script files have two sections."

    miko "The first is always at the start of the file, and is a list of
          declarations. It's used to declare things like characters,
          images, and saveable variable."

    miko "The rest of the file is a list of statements."

    miko "Statements are used to control the actual way the game runs.
          This includes showing dialog, menus, and images."

    miko "Some statements can contain blocks of code. A block of code is
          indented to some level, and ends when some code that is not as
          indented is found."

    miko "Blocks are used to group statements, such as things to do if
          a choice is chosen from a menu."

    miko "Normally, control goes from one statement to the next, in the
          order they appear in the file. But some things change this,
          like if, jump, and menu statements."

if not everything:
    jump end

label dialogue:

    scene store18
    show miko happy

    miko "The heart of any visual novel is the dialogue used to tell
          the story. So Ren'Py makes it easy to write dialogue."

    miko "Dialogue statements don't require any command."

    miko "Instead, a string by itself is a dialogue statement. So are
          two strings next to one another, and so is a variable name
          next to a string."

    miko "You can write strings by including text in double-quotes.
          Strings can span multiple lines, simply by not closing the
          string until your done. Backslash escapes are also supported,
          like \\\", \\n, and \\\\. Escapes are used to include special
          characters in a string."

    miko "A single string is usually used to represent actions, player thoughts,
          and player dialogue. Does that seem right?"

    "I think so."

    miko "Good! A pair of strings is used to represent dialogue from characters
          that we don't know well..."

    "Passerby" "Keep it down!"

    show miko mad

    miko "... like him."

    show miko happy

    miko "Main characters like me have a special syntax. You can declare us
          with a character statement at the start of the file, and then just
          give a name and a string. That's how I'm talking to you now."

    miko "All dialogue is automatically wrapped, so you don't have to do it
          by hand."

if not everything:
    jump end

label menus:

    scene store20
    show miko happy

    miko "Menus let the user pick from different paths of events."

    miko "A menus begins with a 'menu:' statement, which is followed by
          an indented block."

    miko "The block can, but isn't required to, begin with a string on a line by
          itself.
          This is the menu label, which can be used to introduce the choices
          in the menu."

    miko "This is then followed by choice string. Each choice is a string follwed
          by a colon ':'."

    miko "Each choice string is followed by an indented block, containing
          the statements that should be run when the choice is selected.
          When control hits the end of the block, it goes to the statement
          after the end of the menu."

    miko "That's all there is to say about menus. Let's try one."

    menu:
        "Do you understand menus?"

        "Yes.":
            show miko vhappy
            miko "Good!"
            show miko happy
            jump done_menus
          
        "No.":
            pass

    menu:
        "Do you want to repeat this section?"

        "Yes.":
            jump menus

        "No.":
            pass

label done_menus:

if not everything:
    jump end

label scenes:

    miko "Since you're trying to make a visual novel, being able to
          draw pictures is important."

    miko "Each picture in the system is given a name, consisting of
          one or more words."

    miko "Pictures are declared using the 'image' statement. This statement
          takes a name, a colon, and then a file from which to read the image."

    miko "For example,
          \n
          \n\timage miko happy : \"Char1.png\"
          \n
          \ndeclares an image with the name 'miko happy'."

    miko "Scenes are introduced by the scene command. This command clears
          the scene list, and then shows the image given. Normally, this
          image is the background for the scene."

    scene store21

    miko "Since the scene list was cleared, you can no longer see me until
          a show command runs."

    show miko happy

    miko "The show command lets you show an image without clearing the list."

    show miko vhappy

    miko "A second show command will remove any image from the scene list
          for which the first word in the name matches the first word of
          the newly added image."

    show miko happy

    miko "If the first word is a character name, this will hide the old
          image of that character, so you don't have to do it explicitly.
          This makes it easy for characters to change looks or emotions."

    hide miko

    miko "The hide command will remove from the scene list any matching
          image."

    show miko happy

    miko "Images are displayed with the first added in the back and the
          newest in the front."

    miko "And that's all there is to pictures and scenes."

if not everything:
    jump end

label control:

    scene store20
    show miko happy

    miko "The script language supports labels, which are places in the program
          that can be jumped to."

    miko "A label is a label or menu statement with a name."

    miko "The jump statement jumps control to a different location in the
          program."

    miko "Among other things, it can be used to skip unwanted statements."

    jump control_skipped

    miko "Like here, where I confess my eternal and undying love for you."

label control_skipped:

    pass

    miko "The pass statement can be used when a statement is needed,
          but none is wanted."

if not everything:
    jump end

label python:

    scene store18
    show miko happy

    miko "I'm not really a programmer, so I don't know much about the
          python features. I'll tell you what I do know, however."

    miko "Lines beginning with a dollar sign '$' are python statements,
          which can be used to call python functions or assign values
          to variables."

    $ name = prompt("For example, I can ask you your name.", 25)

    miko "These variables can be accesed using %% substitutions in
          strings. Isn't that right, %(name)s?"

    miko "If statements take a python expression, and run a block of
          statements if it is true. An optional else block gives what
          to do if it is false."

    miko "You can call the save function with a list of variables that
          should be saved and restored when the game is saved or loaded."

    miko "There's more to it than this, but this is enough to get you
          started. Read the source (it's open) or ask the programmer if
          you want to know more."

if not everything:
    jump end

label todo:

    scene store19
    show miko happy

    miko "In the future we plan to implement more things."

    miko "Music and sounds will be easy, but we're waiting for somebody to
          request it."

    miko "We also plan to implement animation and special effects, but
          they may be harder."

    miko "But not too hard... if it's something that's possible in PyGame,
          it's ususally pretty easy."

            
label end:

    miko "Well, that's it. Is there anything else you want to know about?"

    menu m3:
        "Ask about Ren'Py features.":
            jump features
            
        "Ask about writing scripts.":
            jump scripts

        "No, that's it.":
            pass

    show miko vhappy

    miko "Thank you for letting me tell you about Ren'Py."
    miko "Have a nice day!"

if name and asked:

    show miko happy

    miko "You know, %(name)s, you're kinda cute."
    miko "Do you want to get coffee sometime..."

scene black

"Ren'Py is brought to you by PyTom."
"Miko is courtesy Blue Lemma, and is used with permission. Check her out
 in fun games such as Tales of Lemma 1, available from
 http://www.lemmasoft.net/."
"Ren'Py was written using Python and Pygame."
"Thank you for sitting through this. Good luck making your own games."
    
# (progn (python-mode) (setq font-lock-keywords (append '(("menu\\|\\$\\|python\\|image\\|character\\|scene\\|show\\|hide" (0 font-lock-keyword-face)) ("\\b\\(label\\)\\s-+\\(\\w+\\):" (1 font-lock-keyword-face) (2 font-lock-function-name-face))) python-font-lock-keywords)) (font-lock-mode 1) (font-lock-fontify-buffer))

