# Copyright 2004 Tom Rothamel <tom-renpy@onegeek.org>
# 
# Permission is hereby granted, free of charge, to any person
# obtaining a copy of this software and associated documentation files
# (the "Software"), to deal in the Software without restriction,
# including without limitation the rights to use, copy, modify, merge,
# publish, distribute, sublicense, and/or sell copies of the Software,
# and to permit persons to whom the Software is furnished to do so,
# subject to the following conditions:
# 
# The above copyright notice and this permission notice shall be
# included in all copies or substantial portions of the Software.
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
# EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
# MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
# NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
# LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION
# OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
# WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

import executive
import textwrap

class TextUI(executive.Executive):

    def wrap(self, s):
        return textwrap.fill(s)

    def keypress(self):
        raw_input("--- Hit return to continue. ---")

    def ui_pre_frag(self):
        pass

    def ui_post_frag(self):
        pass

    def ui_dialog_1(self, what):
        print self.wrap(what)
        self.keypress()

    def ui_dialog_2(self, who, what):
        print who.upper()
        print self.wrap(what)
        self.keypress()

    def ui_menu(self, label, choices):

        if label:
            print self.wrap(label)
            print

        for i, c in enumerate(choices):
            print self.wrap("%d. %s" % (i + 1, c))

        print

        while True:
            rv = int(raw_input("Your choice (1-%d): " % len(choices)))
            if 1 <= rv <= len(choices):
                return rv - 1

    def ui_image(self, a, b, code):
        pass
            
    def ui_reset_scene(self):
        pass

